#ifndef _REALMATRIXP_HPP_
#define _REALMATRIXP_HPP_

class RealMatrixP {
public:
	RealNumber *ele;
	int *dim;
	int col;
	int row;
	
	RealMatrixP()
	{
		row = 0;
		col = 0;
		ele = NULL;
		dim = NULL;
	}
	RealMatrixP(int r, int c)
	{
		row = r;
		col = c;
		ele = NULL;
		dim = NULL;
		allocMemory();
	}
	~RealMatrixP()
	{
		freeMemory();
	}
	void init(int r, int c){
		row = r;
		col = c;
		freeMemory();
		allocMemory();
	}
	void freeMemory()
	{
		if(ele!=NULL) delete [] ele;
		if(dim!=NULL) delete [] dim;
		ele = NULL;
		dim = NULL;
	}
	void allocMemory()
	{
		ele = new RealNumber[row*col];
		dim = new int[row*col];
	}
	RealNumber get(int i, int j){
		return ele[i*col + j];
	}
	void put(int i, int j, RealNumber dat){
		ele[i*col + j] = dat;
	}
	int getDim(int i, int j){
		return dim[i*col + j];
	}
	void putDim(int i, int j, int dat){
		dim[i*col + j] = dat;
	}
	void copyFrom(const RealMatrixP &rm){
		init(rm.row, rm.col);
		int rc = col*row;
		for(int i = 0; i < rc; i++){
			ele[i] = rm.ele[i];
			dim[i] = rm.dim[i];
		}
	}
	void setIdentity(int r){
		init(r, r);
		RealNumber one(1);
		for(int i = 0; i < r; i++){
			put(i,i,one);
		}
		for(int i = 0; i < r; i++){
			for(int j = 0; j < r; j++){
				putDim(i,j,0);
			}
		}
	}
};
#endif
