#ifndef _VARIABLEMATRIXP_HPP_
#define _VARIABLEMATRIXP_HPP_
#include "Variable.hpp"

class VariableMatrixP {
public:
	Variable *ele;
	int *dim;
	int col;
	int row;
	
	VariableMatrixP()
	{
		row = 0;
		col = 0;
		ele = NULL;
		dim = NULL;
	}
	VariableMatrixP(int r, int c)
	{
		row = r;
		col = c;
		ele = NULL;
		dim = NULL;
		allocMemory();
	}
	void init(int r, int c){
		row = r;
		col = c;
		freeMemory();
		allocMemory();
	}
	~VariableMatrixP()
	{
		freeMemory();
	}
	void freeMemory()
	{
		if(ele!=NULL) delete [] ele;
		if(dim!=NULL) delete [] dim;
		ele = NULL;
		dim = NULL;
	}
	void allocMemory()
	{
		ele = new Variable[row*col];
		dim = new int[row*col];
	}
	Variable get(int i, int j){
		return ele[i*col + j];
	}
	void put(int i, int j, Variable dat){
		ele[i*col + j] = dat;
	}
	int getDim(int i, int j){
		return dim[i*col + j];
	}
	void putDim(int i, int j, int dat){
		dim[i*col + j] = dat;
	}
};
#endif
